package com.rjconsultores.ventaboletos.dao.hibernate;

import org.hibernate.SQLQuery;
import org.hibernate.SessionFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.TaxaEmbarqueDAO;
import com.rjconsultores.ventaboletos.dao.sqlbuilder.SQLBuilder;

@Repository("taxaEmbarqueDAO")
public class TaxaEmbarqueHibernateDAO extends GenericHibernateDAO<Object, Integer> implements TaxaEmbarqueDAO {

	@Autowired
	private SQLBuilder sqlBuilder;

	@Autowired
	public TaxaEmbarqueHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}

	@Override
	public void atualizarTaxaEmbarque(Integer rutaId, Integer usuarioId) {
		// Atualizo a taxa de embarque de acordo a parada e km
		SQLQuery query = getSession().createSQLQuery(sqlBuilder.getSQLTaxaEmbarque1(rutaId, usuarioId));
		query.executeUpdate();

		// Atualizo a taxa de embarque de acordo a km do orgao
		query = getSession().createSQLQuery(sqlBuilder.getSQLTaxaEmbarque2(rutaId, usuarioId));
		query.executeUpdate();

		// Atualizo a taxa de embarque de acordo a parada e valor fixo
		query = getSession().createSQLQuery(sqlBuilder.getSQLTaxaEmbarque3(rutaId, usuarioId));
		query.executeUpdate();
	}

}
